import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Buttons
 * 
 * @author Jochen Rbenach
 * @version 1.7
 */
public class ButtonsPanel extends JPanel
{
	private Visualization visualization;

	/**
	 * Konstruktor
	 * 
	 * @param visualization Visualization 
	 */
	public ButtonsPanel(Visualization visualization)
	{
		super();
		this.visualization = visualization;
		int count = visualization.getPlayerCount();
		Container cp = this;
		cp.setLayout(new GridLayout(count, 1)); //Layout festlegen
		Happenings tuwas = new Happenings(visualization);

		//erzeuge "Radiobuttons", von denen nur einer gleichzeitig gedrckt werden kann
		ButtonGroup bg = new ButtonGroup();

		JRadioButton[] buttons = new JRadioButton[count];
		for (int i = 0; i < count; i++)
		{
			buttons[i] = new JRadioButton("Spieler " + (i + 1));
			cp.add(buttons[i]); //buttons hinzufgen
			buttons[i].addActionListener(tuwas); //buttons ActionListener zuordnen
			bg.add(buttons[i]);

		}
		buttons[visualization.getCurPlayerNum()].setSelected(true); //einen Button von Anfang an drcken
	}

}