/**
 * Diese Klasse implementiert den Fangvorgang des Torwarts.
 * 
 * @author Sebastian Hantsch
 * @version 1.0
 */
public class CatchAction extends BasicAction
{
	/**
	 * Neue <code>CatchAction</code> erzeugen.
	 * @param worldModel Referenz zum Weltmodell
	 * @param sender Referenz zum Sender
	 */
	public CatchAction(WorldModel worldModel, Sender sender)
	{
		super(worldModel, sender);
	}

	/**
	 * Aktion fortsetzen
	 */		
	public void resume()
	{
		// Ist der Ball in Fangreichweite?
		if (RoboCupMath.distance(worldModel.getYourself().getPosition(), worldModel.getBall().getPosition()) < 2)
		{
			// Ja, also in Richtung Ball fangen
			sender.doCatch(worldModel.getBall().getDirection());			
		}
		// Aktion beendet
		actionFinished = true;
		actionPending = false;
	}
}
