/**
 * Klasse fr die Bewertung der Abwehr
 * 
 * @author Jrg Zentgraf
 * @version 1.0
 */

public class DefenseRating extends Rating 
{
  	/**
  	 * Konstruktor
  	 * @param worldModel WeltModell
  	 * @param movement Movement
  	 * @param sender Sender
  	 */ 
	public DefenseRating(WorldModel worldModel, Movement movement, Sender sender)
	{
		super(worldModel,movement,sender);
		counter=0;
	}   

   
   
   /**
    * Ausfhrung der Bewertung
    */
   public void execute()
   {
   		hero = worldModel.getYourself();
   		ball = worldModel.getBall();
   		Arrow myPos = hero.getPosition();
   		Arrow ballPos = ball.getPosition();
   		int ballAge = worldModel.getActTime() - worldModel.getBall().getTime();
   		int number=hero.getNumber();
   		
   		//whle Kommando aus
   		chooseCommand();
   		//Bei gegnerischem Freistoss nicht rennen
   		checkRun();

		if (isGameBreak())
		{
			//Bei Anstoss
			//auf die Startposition bewegen
			//und Richtung (0,0) drehen
	   		Arrow startPos=Formation.getStartPosition(number,kickoff(),
	   					worldModel.getOurScore(),worldModel.getPlayDirection());
			if (RoboCupMath.distance(myPos, startPos) > 0.5)
				movement.move(startPos);
			else
				startTurn();
		}
		else
		{
			//Wenn du nicht auf dem Spielfeld ist,
			//drehe dich, bis du Linien siehst,
			//und renne wieder ins Spielfeld
			if (!worldModel.isOnField())
			{
				if (worldModel.isLineVisible())
					movement.dash(80);			
				else
					if (counter%2==0)
						movement.turn(60);
			}
			else
			{
				

			double ballDiff = RoboCupMath.distance(worldModel.getYourself().getPosition(), worldModel.getBall().getPosition());

			if (ballAge < 5 && !isOwnGoalKick())
			{
				//Ball in der Nhe, dann schiessen
				if (kickable())
					{
						if (command.equals("ClearBall"))
							movement.kickToPos(getKickTarget());
						if (command.equals("PassBall"))
							movement.kickToPos(getKickTarget());
						if (command.equals("ScoreGoal"))
							movement.kickToGoal();	
					}
				else 
					//Ist der Ball nah, hinrennen
					if (ballDiff < 10)
						movement.run(getBallCollCourse());
					else	
					{	
						// Ball auf relevanter Position ?
						if (isRelevantPos())
							movement.run(getBallCollCourse());
						else
						{
							//Rcke bis zur x-Position des Balles zurck
							if (ballPos.getX()<myPos.getX())
								movement.run(new Arrow(ballPos.getX(),myPos.getY()));
							else
								movement.run(Formation.getPreferredPos(number));
						}
					}
			}
			//Bei Abstoss auf vorgegebene Position rennen
			else if (isOwnGoalKick())
				movement.run(Formation.goalKickPos(number));
			else	
			{
				//Ball suchen oder zur Preferred Position rennen
				if (ballAge > 10)
					searchBall();
				else
				{
					if (ballPos.getX()<myPos.getX())
						movement.run(new Arrow(ballPos.getX(),myPos.getY()));
					else
						movement.run(Formation.getPreferredPos(number));					
				}
			}
			}
		}	
		counter++;
   }
}
