/**
 * Klasse mit den Aufstellungen
 * 
 * @author Jrg Zentgraf
 * @version 1.0
 */

public class Formation
{
	private static boolean starter[]=new boolean[12];
	
	private Formation()
	{
	}
	
	/**
	 * Aufstellung fr Anstoss
	 * @param int Spielernummer
	 * @param int Wer hat Anstoss ?
	 * @return <i>Arrow</i> StartPosition
	 */
	public static Arrow getStartPosition(int number, int kickoff, int ourScore, char direction)
	{
		//Torwart steht immer auf der gleichen Position
		if (number==1)
			return new Arrow(-48,0);
			
		// Der Gegner hat Anspiel
	    if (kickoff==-1)
	    {
	    	//Wir haben 1 Tor geschossen
	    	if (ourScore==1)
	    	{
	    		if (direction=='l')
	    		{
			    	if (!starter[number])
		 		   	{
		 		   		starter[number]=true;
		   	 			switch (number)
	 		   			{
	   	 					case 2: return new Arrow(-25,-5);
		   	 				case 3: return new Arrow(-23,-7);
		    				case 4: return new Arrow(-21,-9);
		 	 	  			case 5: return new Arrow(-19,-11);
		  	 	 			case 6: return new Arrow(-19,-9);
	 	 	  				case 7: return new Arrow(-19,-6);
	  	 	 				case 8: return new Arrow(-19,-3);
	    					case 9: return new Arrow(-19,0);	
		    				case 10: return new Arrow(-19,3);
		    				case 11: return new Arrow(-19,6);
		 		   		}
		  		  	}
	 	 		  	else
	  			  	{
	  			  		starter[number]=false;
	  			  		switch (number)
	  		 	 		{
		    				case 2: return new Arrow(-24,-6);
			    			case 3: return new Arrow(-22,-8);
			    			case 4: return new Arrow(-20,-10);
	 		 	  			case 5: return new Arrow(-19,-11);
	  		 	 			case 6: return new Arrow(-19,-8);
	    					case 7: return new Arrow(-19,-5);
	    					case 8: return new Arrow(-19,-2);
		    				case 9: return new Arrow(-19,1);	
			    			case 10: return new Arrow(-19,4);
			    			case 11: return new Arrow(-19,7);	  		  			
		  		  		}
		  		  	}
	    		}
		  		else
		  		{
			    	if (!starter[number])
		 		   	{
		 		   		starter[number]=true;
		   	 			switch (number)
	 		   			{
	 		   				case 2: return new Arrow(-13,5);
		   	 				case 3: return new Arrow(-15,7);
		    				case 4: return new Arrow(-17,9);
		 	 	  			case 5: return new Arrow(-19,11);
		  	 	 			case 6: return new Arrow(-19,9);
	 	 	  				case 7: return new Arrow(-19,6);
	  	 	 				case 8: return new Arrow(-19,3);
	    					case 9: return new Arrow(-19,0);	
		    				case 10: return new Arrow(-19,-3);
		    				case 11: return new Arrow(-19,-6);
		 		   		}
		  		  	}
	 	 		  	else
	  			  	{
	  			  		starter[number]=false;
	  			  		switch (number)
	  		 	 		{
		    				case 2: return new Arrow(-14,6);
			    			case 3: return new Arrow(-16,8);
			    			case 4: return new Arrow(-18,10);
	 		 	  			case 5: return new Arrow(-19,11);
	  		 	 			case 6: return new Arrow(-19,8);
	    					case 7: return new Arrow(-19,5);
	    					case 8: return new Arrow(-19,2);
		    				case 9: return new Arrow(-19,-1);	
			    			case 10: return new Arrow(-19,-4);
			    			case 11: return new Arrow(-19,-7);	  		  			
		  		  		}
	  			  	}		  		  		
		  		  		
	    		}
	    	}	
	    	
	    	//Wir haben 7 Tore geschossen
	    	if (ourScore==7)
	    	{
	    		if (direction=='l')
	    		{
			    	if (!starter[number])
		 		   	{
		 		   		starter[number]=true;
		   	 			switch (number)
	 		   			{
	   	 					case 2: return new Arrow(-19,-7);
		   	 				case 3: return new Arrow(-17,-7);
		    				case 4: return new Arrow(-15,-7);
		 	 	  			case 5: return new Arrow(-13,-7);
		  	 	 			case 6: return new Arrow(-11,-6);
	 	 	  				case 7: return new Arrow(-13,-4);
	  	 	 				case 8: return new Arrow(-15,-2);
	    					case 9: return new Arrow(-17,0);	
		    				case 10: return new Arrow(-19,2);
		    				case 11: return new Arrow(-10,-7);
		 		   		}
		  		  	}
	 	 		  	else
	  			  	{
	  			  		starter[number]=false;
	  			  		switch (number)
	  		 	 		{
		    				case 2: return new Arrow(-18,-7);
			    			case 3: return new Arrow(-16,-7);
			    			case 4: return new Arrow(-14,-7);
	 		 	  			case 5: return new Arrow(-12,-7);
	  		 	 			case 6: return new Arrow(-12,-5);
	    					case 7: return new Arrow(-14,-3);
	    					case 8: return new Arrow(-16,-1);
		    				case 9: return new Arrow(-18,1);	
			    			case 10: return new Arrow(-20,3);
			    			case 11: return new Arrow(-10,-7);	  		  			
		  		  		}
		  		  	}
	    		}
		  		else
		  		{
			    	if (!starter[number])
		 		   	{
		 		   		starter[number]=true;
		   	 			switch (number)
	 		   			{
	 		   				case 2: return new Arrow(-10,7);
		   	 				case 3: return new Arrow(-12,7);
		    				case 4: return new Arrow(-14,7);
		 	 	  			case 5: return new Arrow(-16,7);
		  	 	 			case 6: return new Arrow(-18,7);
	 	 	  				case 7: return new Arrow(-17,6);
	  	 	 				case 8: return new Arrow(-15,4);
	    					case 9: return new Arrow(-13,2);	
		    				case 10: return new Arrow(-11,0);
		    				case 11: return new Arrow(-9,-2);
		 		   		}
		  		  	}
	 	 		  	else
	  			  	{
	  			  		starter[number]=false;
	  			  		switch (number)
	  		 	 		{
		    				case 2: return new Arrow(-11,7);
			    			case 3: return new Arrow(-13,7);
			    			case 4: return new Arrow(-15,7);
	 		 	  			case 5: return new Arrow(-17,7);
	  		 	 			case 6: return new Arrow(-18,7);
	    					case 7: return new Arrow(-16,5);
	    					case 8: return new Arrow(-14,3);
		    				case 9: return new Arrow(-12,1);	
			    			case 10: return new Arrow(-10,-1);
			    			case 11: return new Arrow(-8,-3);	  		  			
		  		  		}
	  			  	}		  		  		
		  		  		
	    		}
	    	}	
	    	if (ourScore==2)
	    	{
	    		if (direction=='r')
	    		{
	    			switch (number)
	    			{
	    				case 2: return new Arrow(-26.7,-9);
			    		case 3: return new Arrow(-23.8,-9);
			    		case 4: return new Arrow(-20.5,-9);
			    		case 5: return new Arrow(-21.7,-6.3);
			    		case 6: return new Arrow(-23.3,-3.8);
			    		case 7: return new Arrow(-24.7,-0.7);
			    		case 8: return new Arrow(-25.6,1.8);
			    		case 9: return new Arrow(-24.5,4.4);
			    		case 10: return new Arrow(-21.7,5.6);
	 			   		case 11: return new Arrow(-19.6,4.5);	    				
	    			}
	    		}
	    		else
	    		{
	    			switch (number)
	    			{
	    				case 2: return new Arrow(-27.6,-8.1);
			    		case 3: return new Arrow(-25.9,-9.3);
			    		case 4: return new Arrow(-27.4,2.6);
			    		case 5: return new Arrow(-23.6,-8.3);
			    		case 6: return new Arrow(-22.5,-6.4);
			    		case 7: return new Arrow(-24.2,-3.8);
			    		case 8: return new Arrow(-25.5,-1.6);
			    		case 9: return new Arrow(-26.8,0.5);
			    		case 10: return new Arrow(-25.1,2.6);
	 			   		case 11: return new Arrow(-22.5,2.6);	    				
	    			}
	    		}
	    	}	    				
	    	//Wir haben weder 1 noch 7 Tore	    	    	
	    	switch (number)
	    	{
	    		case 2: return new Arrow(-40,-2);
	    		case 3: return new Arrow(-40,0);
	    		case 4: return new Arrow(-40,2);
	    		case 5: return new Arrow(-20,-3);
	    		case 6: return new Arrow(-20,-1);
	    		case 7: return new Arrow(-20,1);
	    		case 8: return new Arrow(-20,3);
	    		case 9: return new Arrow(-10,-15);
	    		case 10: return new Arrow(-10,0);
	    		case 11: return new Arrow(-10,15);
			}
	    }
	    
	    //Wir haben Anspiel
	    if (kickoff==1)
	    {
 		   	switch (number)
	    	{
	    		case 2: return new Arrow(-30,-20);
	    		case 3: return new Arrow(-30,0);
	    		case 4: return new Arrow(-30,20);
	    		case 5: return new Arrow(-20,-30);
	    		case 6: return new Arrow(-20,-10);
	    		case 7: return new Arrow(-20,10);
	    		case 8: return new Arrow(-20,30);
	    		case 9: return new Arrow(-1,-20);
	    		case 10: return new Arrow(-5,0);
	    		case 11: return new Arrow(-1,20);
	    	}
	    }
    	//default Rckgabewert
		return new Arrow(0,0);
	}
	
	/**
	 * liefert PreferredPosition fr jeden Spieler
	 * @param int Spielernummer
	 * @return <i>Arrow</i> Preferred Position
	 */
	public static Arrow getPreferredPos(int number)
	{
		switch (number)
		{
			case 1: return new Arrow(-48,0);
			case 2: return new Arrow(-20,-20);
			case 3: return new Arrow(-20,0);
			case 4: return new Arrow(-20,20);
			case 5: return new Arrow(-5,-25);
			case 6: return new Arrow(-5,-10);
			case 7: return new Arrow(-5,10);
			case 8: return new Arrow(-5,25);
			case 9: return new Arrow(-0.5,-20);
			case 10: return new Arrow(-0.5,0);
			case 11: return new Arrow(-0.5,20);
		}
		return new Arrow(0,0);
	}
	
	/**
	 * Positionen der Abwehrspieler bei eigenem Abstoss
	 * @param int Spielernummer
	 * @return <i>Arrow</i> Goal Kick Position
	 */
	public static Arrow goalKickPos(int number)
	{
		switch (number)
		{
			case 2: return new Arrow(-30,-20);
			case 3: return new Arrow(-30,0);
			case 4: return new Arrow(-30,20);
		}
		return new Arrow(0,0);
	}
	
}

