/**
 * Klasse fr die Bewertung des Sturms
 * 
 * @author Jrg Zentgraf
 * @version 1.0
 */

public class ForwardRating extends Rating 
{
	/**
	 * Konstruktor
	 * @param worldModel Weltmodell
	 * @param movement Movement
	 * @param sender Sender
	 */	   
	public ForwardRating(WorldModel worldModel,Movement movement, Sender sender)
 	{
		super(worldModel,movement,sender);
		counter=0;

 	}
	
	/**
	 * Fhrt die Angriffsbewertung aus
	 */
	public void execute()
	{
		hero = worldModel.getYourself();
		ball = worldModel.getBall();
		int ballAge = worldModel.getActTime() - worldModel.getBall().getTime();
		Arrow myPos = hero.getPosition();
		Arrow ballPos = ball.getPosition();	

		int number=hero.getNumber();		
		Arrow preferredPos = Formation.getPreferredPos(number);

   		//whle Kommando aus
   		chooseCommand();
   		//Bei gegnerischem Freistoss nicht rennen
   		checkRun();
		
		if (isGameBreak())
		{
			//Bei Anstoss
			//auf die Startposition bewegen
			//und Richtung (0,0) drehen
	   		Arrow startPos=Formation.getStartPosition(number,kickoff(),
	   					worldModel.getOurScore(),worldModel.getPlayDirection());
			if (RoboCupMath.distance(myPos, startPos) > 0.5)
				movement.move(startPos);
			else
				startTurn();
		}
		else
		{
			if (worldModel.isOnField())
			{
				// Ball sichtbar?
				if (ballAge < 15)
				{

					// Ball in Schureichweite?
					double ballDiff = RoboCupMath.distance(myPos, ballPos);

					if (kickable())
					{
						if (command.equals("ClearBall"))
							movement.kickToGoal();
						if (command.equals("PassBall"))
							movement.kickToPos(getKickTarget());
						if (command.equals("ScoreGoal"))
							movement.kickToGoal();	
					}
					else if (ballDiff < 10)
						//Ist der Ball nah, hinrennen					
						movement.run(getBallCollCourse());
					else
					{
						// Ball im gegnerischen Gebiet?
						if (isRelevantPos())
							movement.run(getBallCollCourse());
						else
						{
							if (ballPos.getX()>myPos.getX())
								movement.run(new Arrow(ballPos.getX(),myPos.getY()));
							else
								movement.run(preferredPos);
						}
					}
				}
				else
				{
					if (ballAge > 10)
						// Ball suchen
						searchBall();
					else
						movement.run(preferredPos);
				}
			}
			else
			{
				//Wenn du nicht auf dem Spielfeld ist,
				//drehe dich, bis du Linien siehst,
				//und renne wieder ins Spielfeld				
				if (worldModel.isLineVisible())
					movement.dash(80);			
				else
					if (counter%2==0)
						movement.turn(60);
			}
		}
		counter++;


		
	}
}
