/**
 * Basisklasse fr unseren Spieler (den Helden..)
 * 
 * 23.05.02 Initialversion (T)
 * 24.05.02 SetMethoden hinzugefgt (F)
 * 25.05.02 Implementation von hear (T)
 * 26.05.02	Initialisierung im Konstruktor
 * 07.06.02 get/set TurnCount/MoveCount hinzugefgt (F)
 * 12.06.02	Konstruktor berarbeitet und viewAngle mit
 * 			get/set Methoden hinzugefgt
 * 
 * @author Torben Barth & Florian Strobel
 * @version 1.05
 */

import java.util.Vector;

public class Hero extends Player
{
	//enthalten die Spielereigenschaften wie im Manual beschrieben	
	private double stamina;
	private String viewModeInterval;
	private String viewModeAngle;
	private double effort;
	private double viewAngle; // in degree!
	private double headAngle;
	private Vector heardText;
	private int TurnCount;
	private int MoveCount;

	/**
	 * Konstruktor
	 * initialisiert einen "Hero"
	 * @param pos Postitions-Arrow
	 * @param vec Geschwindigkeits/Richtungs-Arrow
	 * @param wm WorldModel
	 */

	public Hero(Arrow pos, Arrow vec, WorldModel wm)
	{
		super(pos, vec, wm);
		stamina = 4000;
		viewModeInterval = "high";
		viewModeAngle = "normal";
		effort = 1;
		viewAngle = 0;
		headAngle = 0;
		heardText = new Vector();
		TurnCount = 0;
		MoveCount = 0;
	}

	/**
	 * Gibt die Ausdauer zurck
	 * @return stamina double
	 */

	public double getStamina()
	{
		return stamina;
	}

	/**
	 * Legt die Ausdauer fest
	 * @param stamina double
	 */

	public void setStamina(double stamina)
	{
		this.stamina = stamina;
	}

	/**
	 * gibt an welche Sichtweite gewhlt ist
	 * @return viewModeInterval String
	 */
	public String getViewModeInterval()
	{
		return viewModeInterval;
	}

	/**
	 * legt die Sichtweite fest
	 * @param viewModeInterval String
	 */
	public void setViewModeInterval(String viewModeInterval)
	{
		this.viewModeInterval = viewModeInterval;
	}

	/**
	 * gibt an welcher Sichtwinkel gewhlt ist
	 * @return viewModeAngle String
	 */
	public String getViewModeAngle()
	{
		return viewModeAngle;
	}

	/**
	 * legt den Sichtwinkel fest
	 * @param viewModeAngel String
	 */
	public void setViewModeAngle(String viewModeAngle)
	{
		this.viewModeAngle = viewModeAngle;
	}

	/**
	 * gibt den Wert der Kraft an (double)
	 * @return effort double
	 */
	public double getEffort()
	{
		return effort;
	}

	/**
	 * legt den Wert der Kraft fest (double)
	 * @param effort double
	 */
	public void setEffort(double effort)
	{
		this.effort = effort;
	}

	/**
	 * gib den Winkel des Kopfes zum Vektor an
	 * @return headAngle double
	 */
	public double getHeadAngle()
	{
		return headAngle;
	}

	/**
	 * legt den Winkel des Kopfes zum Vektor fest
	 * @param headAngle double
	 */
	public void setHeadAngle(double headAngle)
	{
		this.headAngle = headAngle;
	}

	/**
	 * gibt an wieviele Textnachrichten gespeichert sind
	 * @return heardTextCount int
	 */
	public int getHeardTextCount()
	{
		return heardText.size();
	}

	/**
	 * Gibt das HearEvent zurck, das an der Textstelle steht.
	 * @param textstelle int
	 * @return HearEvent
	 */
	public HearEvent getHeardText(int textstelle)
	{
		return (HearEvent) heardText.elementAt(textstelle);
	}

	/**
	 * Gibt die Nachricht zurck die an der Textstelle steht.
	 * @param textstelle int
	 * @return HeradText String
	 */
	public String getHeardMessage(int textstelle)
	{
		return getHeardText(textstelle).getMessage();
	}

	/**
	 * Gibt die Richtung der Meldung zurck der an der Textstelle steht.
	 * @param int textstelle
	 * @return Direction double
	 */
	public double getHeardDirection(int textstelle)
	{
		return getHeardText(textstelle).getDirection();
	}

	/**
	 * lscht den gehrten Text an der i-ten Stelle 
	 * @param i int Stelle der zu lschenden Nachricht
	 */
	public void clearHeardText(int i)
	{
		heardText.remove(i);
	}

	/**
	 * fgt den gehrten Text in heardText an
	 * @param hear HearEvent
	 */
	public void addHeardText(HearEvent hear)
	{
		heardText.addElement(hear);
	}
	
	/**
	 * gibt den viewAngle.aus
	 * @return viewAngle double
	 */
	public double getViewAngle()
	{
		return viewAngle;
	}

	/**
	 * setzte den viewAngle
	 * @param viewAngle double
	 */
	public void setViewAngle(double viewAngle)
	{
		this.viewAngle = viewAngle;
	}
	
	/**
	 * gibt an wieoft sich der Hero gedreht hat
	 *@return TurnCount int 
	 */
	public int getTurnCount()
	{
		return TurnCount;
	}
	
	/**
	 * setzt die Anzahl der Drehungen
	 * @param TurnCount int
	 */
	public void setTurnCount(int TurnCount)
	{
		this.TurnCount = TurnCount;
	}

	
	/**
	 * gibt die Anzahl der Bewegungen zurck
	 * @return MoveCount int
	 */
	public int getMoveCount() 
	{
		return MoveCount;
	}


	/**
	 * Setzte die Anzahl der Bewegungen
	 * @param moveCount int
	 */
	public void setMoveCount(int MoveCount) 
	{
		this.MoveCount = MoveCount;
	}
	
}