import javax.swing.*;
import java.awt.*;

/**
 * Labels
 * 
 * @author Jochen Rbenach
 * @version 1.7
 */

public class LabelsPanel extends JPanel
{
	private WorldModel worldModel; //Referenz
	//Beschriftungen
	private JLabel zeit;
	private JLabel matchStatus;
	private JLabel ausgewaehlt;
	private JLabel mitspieler;
	private JLabel	ball;
	private JLabel gegenspieler;
	private JLabel unbekannte;
	private JLabel leer;
	
	/**
	 * Konstruktor 
	 * 
	 * @param worldModel WorldModel
	 */
	public LabelsPanel(WorldModel worldModel)
	{
		super();
		this.worldModel = worldModel;
		Container cp = this;
		cp.setLayout(new GridLayout(3,3)); //Layout festlegen
		if (worldModel != null) //wenn existiert
		{
			zeit = new JLabel("Zeit: " + worldModel.getActTime());
			matchStatus =
				new JLabel("Matchstatus: " + worldModel.getMatchStatus());
		}
		else
		{
			zeit = new JLabel("Zeit: unbekannt");
			matchStatus =
				new JLabel("Matchstatus: unbekannt");
		}
		
		ausgewaehlt = new JLabel("ausgewaehlter Spieler");
		ausgewaehlt.setForeground(new Color(253, 0, 203)); //festlegen der Schriftfarbe
		
		mitspieler = new JLabel("Mitspieler");
		mitspieler.setForeground(new Color(255, 2, 2)); //festlegen der Schriftfarbe
		
		ball = new JLabel("Ball");
		ball.setForeground(Color.gray); //festlegen der Schriftfarbe
		
		gegenspieler = new JLabel("Gegenspieler");
		gegenspieler.setForeground(new Color(2, 14, 255)); //festlegen der Schriftfarbe
		
		unbekannte = new JLabel("unbekannte Spieler");
		unbekannte.setForeground(new Color(251, 243, 6)); //festlegen der Schriftfarbe
		
		leer = new JLabel(""); //erzeuge leeres Panel um gewnschtes Layout zu erzeugen
		
		//Labels dem Container hinzufgen
		cp.add(zeit);
		cp.add(ausgewaehlt);
		cp.add(gegenspieler);
		cp.add(matchStatus, BorderLayout.WEST);
		cp.add(mitspieler);
		cp.add(unbekannte);
		cp.add(leer);
		cp.add(ball);
		
	}

	/**
	 * updated Zeit und matchStaus 
	 */
	public void updateContent()
	{
		if (worldModel != null)
		{
			zeit.setText("Zeit: " + worldModel.getActTime());
			matchStatus.setText("Matchstatus: " + worldModel.getMatchStatus());
		}
	}

	/**
	 * Sets the worldModel.
	 * 
	 * @param worldModel The worldModel to set
	 */
	public void setWorldModel(WorldModel worldModel)
	{
		this.worldModel = worldModel;
	}
}
