/**
 * Diese Klasse enthlt die Bewertung fr einen Mittelfeldspieler
 * @author Jrg Zentgraf
 * @version 1.0
 */

public class MidfieldRating extends Rating 
{
   /** 
    * Konstruktor
    * @param worldModel Weltmodell
    * @param movement Movement
    * @param sender Sender
    */
	public MidfieldRating(WorldModel worldModel, Movement movement, Sender sender)
	{
		super(worldModel,movement,sender);
		counter=0;
	}
	
	/** 
	 * Wird bei jedem Zyklus aufgerufen und
	 * bewertet die Aktion fr einen Spieler
	 */
	
	public void execute()
	{
		hero=worldModel.getYourself();
		ball=worldModel.getBall();
		
		int ballAge = worldModel.getActTime() - worldModel.getBall().getTime();
		Arrow myPos = hero.getPosition();		
		Arrow ballPos = ball.getPosition();
		final int number = hero.getNumber();
		
   		//whle Kommando aus
   		chooseCommand();
   		//Bei gegnerischem Freistoss nicht rennen
   		checkRun();

		if (isGameBreak())
		{
			//Bei Anstoss
			//auf die Startposition bewegen
			//und Richtung (0,0) drehen			
	   		Arrow startPos=Formation.getStartPosition(number,kickoff(),
	   					worldModel.getOurScore(),worldModel.getPlayDirection());
			if (RoboCupMath.distance(myPos, startPos) > 0.5)
				movement.move(startPos);
			else
				startTurn();
		}
		else
		{
			if (!worldModel.isOnField())
			{
				//Wenn du nicht auf dem Spielfeld ist,
				//drehe dich, bis du Linien siehst,
				//und renne wieder ins Spielfeld				
				if (worldModel.isLineVisible())
					movement.dash(80);			
				else
					if (counter%2==0)
						movement.turn(60);
			}
			else
			{			
				// Ball sichtbar?
				if (ballAge < 5 && !isOwnGoalKick())
				{
					double ballDiff = RoboCupMath.distance(worldModel.getYourself().getPosition(), ballPos);
					// Ball in Schureichweite?					
					if (kickable())
					{
						if (command.equals("ClearBall"))
							movement.kickToGoal();
						if (command.equals("PassBall"))
							movement.kickToPos(getKickTarget());
						if (command.equals("ScoreGoal"))
							movement.kickToGoal();	
					}					
					else 
						if (ballDiff < 10)
							movement.run(getBallCollCourse());
						else	
						{	
							// Ball im Mittelfeld ?
							if (isRelevantPos())
								movement.run(getBallCollCourse());
							else
								movement.run(Formation.getPreferredPos(number));
						}
					}
				else
				{
					if (ballAge > 10)
						// Ball suchen
						searchBall();
					else
						movement.run(Formation.getPreferredPos(number));
				}	
			}				
		}			
		counter++;
	}
}
