/**
 * Diese Klasse implementiert die direkte Positionierung bei
 * Spielunterbrechungen.
 * 
 * @author Sebastian Hantsch
 * @version 1.0
 */
public class MoveAction extends BasicAction
{
	/** Ziel des Spielers */
	private Arrow destination;

	/**
	 * Erzeugt eine neue <code>MoveAction</code>.
	 * @param worldModel Referenz zum Weltmodell
	 * @param sender Referenz zum Sender
	 */
	public MoveAction(WorldModel worldModel, Sender sender)
	{
		super(worldModel, sender);
		destination = new Arrow();
	}
	
	/**
	 * Aktion fortsetzen
	 */
	public void resume()
	{
		sender.move(destination.getX(), destination.getY());
		actionPending = false;
		actionFinished = true;
	}
	
	/**
	 * Setzt das Ziel fr den Spieler
	 * @param destination das Ziel
	 */
	public void setDestination(Arrow destination)
	{
		this.destination = destination;
	}
}

