/**
 * Basisklasse fr einen Spieler
 * 
 * 23.05.02 Initialversion (T)
 * 24.05.02 setMethoden, erw. Konstruktor (TF)
 * 18.06.02	numberAvailable / goalieAvailable hinzugefgt (T)
 * 
 * @author Torben Barth & Florian Strobel
 * @version 1.02
 */


public class Player extends Things 
{
    private int number;
    private boolean goalie;
    private boolean known;
    private boolean partyMember;
    private boolean numberAvailable;
    private boolean goalieAvailable;
   
  	/**
     *Konstruktor
     * @param pos Arrow
     * @param vec Arrow
     * @param wm WorldModel
     */ 
   	public Player(Arrow pos, Arrow vec, WorldModel wm)
   	{
		super(pos,vec,wm);
		number = -1;
		goalie = false;
		known = false;
		partyMember = false;
		numberAvailable = false;
	}
	
	/**
     * Gibt Spielernummer zurck 
     * @return number int
     */
    public int getNumber() 
    {
    	return number;
    }
	
	/**
     * Legt Spielernummer fest  
     * @param number int
     */
    public void setNumber(int number) 
    {
    	this.number = number;
    }
	
    /**
     * Legt fest, ob ein Spieler Torwart ist oder nicht.
     * @param goalie boolean
     */
    public void setGoalie(boolean goalie) 
    {
    	this.goalie = goalie;
   	}
    
    /**
     * Gibt an ob Spieler Torwart ist oder nicht.
     * !!! Achtung: ist goalieAvailable ?
     * @return goalie boolean
     */ 
    public boolean isGoalie() 
    {
    	return goalie;
   	}
   
    /**
 	 * Gibt an, ob Spieler zu unserer Mannschaft gehrt oder nicht.
 	 * isKnown beachten
     * @return partyMember boolean
     */
    public boolean isPartyMember() 
    {
  	 	return partyMember;
    }
   
    /**
 	 * Legt fest ob Spieler zu unserer Mannschaft gehrt oder nicht.
     * @param partyMember boolean
     */
    public void setPartyMember(boolean partyMember) 
    {
  	 	this.partyMember= partyMember;
    }
   
    /**
     * Gibt an ob der Spieler einer Mannschaft zu zuordnen ist.
     * @return knwon boolean
     */
    public boolean isKnown() 
    {
   		return known;
    }
    
    /**
     * Legt fest, ob der Spieler einer Mannschaft zu zuordnen ist.
     * @param known boolean
     */
    public void setKnown(boolean known) 
    {
   		this.known = known;
    }
    
    /**
     * Gibt an, ob die Nummer verfgbar ist
     * @return numberAvailable boolean
     */
    public boolean isNumberAvailable()
    {
    	return numberAvailable;
    }
    
    /**
     * Setzt numberAvailable
     * @param available boolean
     */
    public void setNumberAvailable(boolean available)
    {
    	numberAvailable = available;
    }
	/**
	 * Returns the goalieAvailable.
	 * @return goaliaAvailable boolean
	 */
	public boolean isGoalieAvailable() {
		return goalieAvailable;
	}


	/**
	 * Setzt goalieAvailable.
	 * @param goalieAvailable boolean
	 */
	public void setGoalieAvailable(boolean goalieAvailable) {
		this.goalieAvailable = goalieAvailable;
	}


}