/**
 * Klasse, die alle absoluten Positionen, der Flaggen und Tore,
 * in einer Hashtabelle enthlt.
 * 
 * 28.05.02	Initialversion (T)
 * 02.06.02	getArrowX und get ArrowY hinzugefgt (F)
 * 			Kommentar an Torbi: "Schicke" Hashtabelle ;-)
 * 05.06.02	Klasse auch fr Spielweise von Rechts nach Links angepasst (T)
 * 
 * @author Torben Barth & Florian Strobel
 * @version 1.02
 */
import java.util.Hashtable;

public class Positions 
{
	private Hashtable pos;
	private WorldModel wm;
	
	/**
	 * Konstruktor
	 * erzeugt Hashtabelle mit allen Postionen der Flaggen und Tore
	 * das WorldModel wird wegen der Spielrichtung bentigt
	 * @param wm WorldModel 
	 */
	public Positions(WorldModel wm)
	{	
		pos = new Hashtable();
		this.wm = wm;
		//die Flaggen...
		pos.put("f c",new Arrow(0,0));
   		pos.put("f c t",new Arrow(0,-34));
   		pos.put("f c b",new Arrow(0,34));
   		pos.put("f l b",new Arrow(-52.5,34));
   		pos.put("f r b",new Arrow(52.5,34));
   		pos.put("f r t",new Arrow(52.5,-34));
   		pos.put("f l t",new Arrow(-52.5,-34));
   		pos.put("f p l t",new Arrow(-36,-20.175));
   		pos.put("f p l b",new Arrow(-36,20.175));
   		pos.put("f p l c",new Arrow(-36,0));;
   		pos.put("f p r t",new Arrow(36,-20.175));
   		pos.put("f p r b",new Arrow(36,20.175));
   		pos.put("f p r c",new Arrow(36,0));
   		pos.put("f g l b",new Arrow(-52.5,7.01));
   		pos.put("f g l t",new Arrow(-52.5,-7.01));
   		pos.put("f g r b",new Arrow(52.5,7.01));
   		pos.put("f g r t",new Arrow(52.5,-7.01));
   		pos.put("f l t 30",new Arrow(-57.5,-30));
   		pos.put("f l t 20",new Arrow(-57.5,-20));
   		pos.put("f l t 10",new Arrow(-57.5,-10));
   		pos.put("f l 0",new Arrow(-57.5,0));
   		pos.put("f l b 30",new Arrow(-57.5,30));
   		pos.put("f l b 20",new Arrow(-57.5,20));
   		pos.put("f l b 10",new Arrow(-57.5,10));
   		pos.put("f r t 30",new Arrow(57.5,-30));
   		pos.put("f r t 20",new Arrow(57.5,-20));
   		pos.put("f r t 10",new Arrow(57.5,-10));
   		pos.put("f r 0",new Arrow(57.5,0));
   		pos.put("f r b 30",new Arrow(57.5,30));
   		pos.put("f r b 20",new Arrow(57.5,20));
   		pos.put("f r b 10",new Arrow(57.5,10));
   		pos.put("f t 0",new Arrow(0,-39));
   		pos.put("f t r 10",new Arrow(10,-39));
   		pos.put("f t r 20",new Arrow(20,-39));
   		pos.put("f t r 30",new Arrow(30,-39));
   		pos.put("f t r 40",new Arrow(40,-39));
   		pos.put("f t r 50",new Arrow(50,-39));
   		pos.put("f t l 10",new Arrow(-10,-39));
   		pos.put("f t l 20",new Arrow(-20,-39));
   		pos.put("f t l 30",new Arrow(-30,-39));
   		pos.put("f t l 40",new Arrow(-40,-39));
   		pos.put("f t l 50",new Arrow(-50,-39));
   		pos.put("f b 0",new Arrow(0,39));
   		pos.put("f b r 10",new Arrow(10,39));
   		pos.put("f b r 20",new Arrow(20,39));
   		pos.put("f b r 30",new Arrow(30,39));
   		pos.put("f b r 40",new Arrow(40,39));
   		pos.put("f b r 50",new Arrow(50,39));
  		pos.put("f b l 10",new Arrow(-10,39));
   		pos.put("f b l 20",new Arrow(-20,39));
   		pos.put("f b l 30",new Arrow(-30,39));
   		pos.put("f b l 40",new Arrow(-40,39));
   		pos.put("f b l 50",new Arrow(-50,39));
		
		//und noch die Tore
   		pos.put("g l",new Arrow(-52.5,0));
   		pos.put("g r",new Arrow(52.5,0));
	}
	
	/**
	 * gibt die Position des Objekts zurck
	 * @param object String
	 * @return position Arrow
	 */
	public Arrow getArrow(String object)
	{	
		//wenn von links nach rechts gespielt wird, 
		//wird der Arrow(Position) des Objektes zurckgegeben
		if (wm.getPlayDirection() == 'l')
			return (Arrow) pos.get(object);
		else
		//ansonsten wird der invertierte Arrow zurckgeben, da bei
		//rechts nach links gerade die Vorzeichen vertauscht sind
			{	
			Arrow temp = new Arrow();
			temp = (Arrow) pos.get(object);;
			temp.invArrow();
			return temp;
			}
	}
	
	/**
	 *gibt den xWert des Objekts zurck, sonst genau wie getArrow
	 *@param object String
	 *@return xPosition double
	 *@see getArrow 
	 */
	public double getArrowX(String object)
	{
		Arrow temp;
		temp = (Arrow) pos.get(object);
		if (wm.getPlayDirection() == 'l')
			return temp.getX();
		else
			return -temp.getX();
	}
	
	/**
	 *gibt den yWert des Objekts zurck, sonst genau wie getArrow
	 *@param object String
	 *@return yPosition double
	 *@see getArrow 
	 */
	public double getArrowY(String object)
	{
		Arrow temp;
		temp = (Arrow) pos.get(object);
		if (wm.getPlayDirection() == 'l')
			return temp.getY();
		else
			return -temp.getY();
	}
}