/**
 * Umsetzung der score-Nachricht als Klasse.
 * 
 * 03.6.2002: processTokens eingefgt
 * 
 * @author Sebastian Hantsch
 * @version 1.1
 */
public class ScoreEvent extends TimeStampedEvent
{
	private int ourScore;
	private int theirScore;

	/**
	 * Erzeugt ein neues ScoreEvent.
	 */
	public ScoreEvent()
	{
		super();
	}

	/**
	 * Liest die Teilstcke von tokens aus und belegt die
	 * Ereignisattribute entsprechend
	 * @param tokens Teilstcke
	 * @return <code>true</code>, falls gltige Anzahl/Art von 
	 * Token, sonst <code>false</code>
	 */
	public boolean processTokens(ParenthesesTokenizer tokens)
	{
		if (super.processTokens(tokens))
		{

			ourScore = Integer.parseInt(tokens.nextToken());
			theirScore = Integer.parseInt(tokens.nextToken());
			return true;
		}
		return false;
	}

	/**
	 * Gibt den Punktestand unseres Teams an.
	 * @return ourScore
	 */
	public int getOurScore()
	{
		return ourScore;
	}

	/**
	 * Gibt den Punktestand des gegnerischen Teams an.
	 * @return theirScore
	 */
	public int getTheirScore()
	{
		return theirScore;
	}
}