import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Score-Label
 * 
 * @author Jochen Rbenach
 * @version 1.4
 */
public class ScorePanel extends JPanel
{
	private WorldModel worldModel;
	private JLabel Score;

	/**
	 * Konstruktor 
	 * 
	 * @param worldModel WorldModel
	 */
	public ScorePanel(WorldModel worldModel)
	{
		super();
		this.worldModel = worldModel;
		Container cp = this;
		if (worldModel != null) //wenn ungleich 0
		{
			Score =
				new JLabel(
					"Heim "
						+ worldModel.getOurScore()
						+ " : "
						+ worldModel.getTheirScore()
						+ "Fremd");
		}
		else
		{
			Score = new JLabel("Heim 0 : 0 Fremd");
		}

		Score.setFont(new Font("SansSerif", Font.ITALIC, 24)); //festlegen der Schrift
		cp.add(Score); //hinzufgen von Score zu Container
	}

	/**
	 * updated Score
	 */
	public void updateContent()
	{
		if (worldModel != null)
		{
			Score.setText(
				"Heim "
					+ worldModel.getOurScore()
					+ " : "
					+ worldModel.getTheirScore()
					+ " Fremd");
		}
	}

	/**
	 * Sets the worldModel.
	 * 
	 * @param worldModel The worldModel to set
	 */
	public void setWorldModel(WorldModel worldModel)
	{
		this.worldModel = worldModel;
	}
}
