/**
 * Abstrakte Basisklasse fr alle Server-Ereignisse
 * 
 * 03.6.2002: processTokens eingefgt
 * 
 * @author Sebastian Hantsch
 * @version 1.1
 */
public abstract class ServerEvent
{
	/** <code>String</code>, der den Ereignisnamen enthlt. */
	protected String name;

	/**
	 * Erzeugt ein neues <code>ServerEvent</code>
	 */
	public ServerEvent()
	{
		name = "";
	}

	/**
	 * Liest die Teilstcke von tokens aus und belegt die
	 * Ereignisattribute entsprechend
	 * @param tokens Teilstcke
	 * @return <code>true</code>, falls gltige Anzahl/Art von 
	 * Token, sonst <code>false</code>
	 */
	public boolean processTokens(ParenthesesTokenizer tokens)
	{
		if (tokens.hasMoreTokens())
		{
			name = tokens.nextToken();
			return true;
		}
		else
		{
			return false;
		}
	}

	/**
	 * Gibt den Ereignisnamen an.
	 * @return Ereignisnamen
	 */
	public String getName()
	{
		return name;
	}
}