/**
 * Klasse fr die Ausfhrung der Bewertung
 * 
 * @author Jrg Zentgraf
 * @version 1.0
 */

public class Strategy 
{
	/** Referenz auf Weltmodell*/
	protected WorldModel worldModel;
	/** Referenz auf Sender */
	protected Sender sender;
	/** Referenz auf Bewertung */
	protected Rating rating;
	/** Referenz auf Movement */
	protected Movement movement;
	/**Rating schon erzeugt ? */
	private boolean created;
   
    /**
     * Konstruktor
     */
	public Strategy() 
	{
		this.worldModel = null;
		this.sender = null;
    }
   
	/**
	 * Setze die Referenzen zum Weltmodell und zum Sender
	 * Erzeuge Movement
	 */	
	public void setReferences(WorldModel worldModel, Sender sender)
	{
		this.worldModel = worldModel;
		this.sender = sender;
		movement = new Movement(sender, worldModel);
		created=false;
	}
   
	/**
	 * Abhngig von der Spielernummer wird die Bewertung ausgefhrt
	 * erhlt die Spielernummer und erzeugt davon abhnig Instanzen der 
	 * verschiedenen Ratings und ruft diese auf
	 */
	public void execute() 
 	{
 		//erzeuge neue Bewertung abhngig von der Spielernummer
 		int number = worldModel.getYourself().getNumber();
 		if (!created)
 		{
 			switch (number)
 			{
 				case 1:
 					rating = new GoalieRating(worldModel,movement,sender);
 					break;	
				case 2:
				case 3:
				case 4:
					rating = new DefenseRating(worldModel,movement,sender);
					break;
					
				case 5:
				case 6:
				case 7:
				case 8:
					rating = new MidfieldRating(worldModel,movement,sender);
					break;
				default:
					rating = new ForwardRating(worldModel,movement,sender);
 			}
 			created=true;
 		}
 		//Fhre die Bewertung aus
 		rating.execute();
 	}   
}
