/**
 * Basiklasse fr eine Objekt auf dem Spielfeld (Ball, Spieler, Mitspieler, Gegner) 
 * 
 * 23.05.02 Initialversion 1.00 (t)
 * 24.05.02 set-Methoden hinzugefgt, Referenz auf Weltmodell fr die aktuelle Zeit eingefgt (tf)
 * 09.06.02 distance und distanceAvailable als Attribut mit get/set hinzugefgt (F)
 * 			direction auch
 * 16.06.02 in setposition avaible false entfernt (T/F) 
 * 			
 * 
 * @author Torben Barth, Florian Strobel
 * @version 1.02
*/


public class Things
{
   private Arrow position;
   private Arrow vector;
   private double distance;
   private boolean distanceAvailable;
   private double direction;
   private boolean directionAvailable;
   
   protected WorldModel wm;
   private int time;
   
   /**
    * Konstruktor
    * initialisiert die Werte
    * @param pos fr die Position (Arrow)
    * @param vec fr den Geschwindigkeits/Richtungs-Vektor (Arrow)
    * @param wm WorldModel
    */
   public Things(Arrow pos, Arrow vec, WorldModel wm) 
   {
    position = pos;
    vector = vec;
    this.wm = wm;
    distance = 0.0;
    distanceAvailable = false;
	direction = 0.0;
	directionAvailable = false;   
   }
   
   /**
    * setzt neue Position und automatisch aktuelle Zeit
    * @param pos Arrow
    */
   public void setPosition(Arrow pos) 
   {
    position.setXY(pos.getX(), pos.getY());
    time = wm.getActTime();
    //distanceAvailable = false;
    //directionAvailable = false;
   }
   
   /**
    * setzt neuen Vektor und automatisch Zeit
    * @param vec Arrow
    */
   public void setVector(Arrow vec) 
   {
    vector.setXY(vec.getX(), vec.getY());
    time = wm.getActTime();
   }
    
   /**
    * liefert die Position
    * @return position Arrow
    */
   public Arrow getPosition() 
   {
    return position;
   }
  
   /**
    * liefert den Vektor
    * @return vector Arrow
    */
   public Arrow getVector() 
   {
    return vector;
   }
   
   /**
    * liefert die Zeit der letzten Aktualisierung
    * @return time int
    */
   public int getTime() 
   {
    return time;
   }
   
/**
 * gibt die Entfernung zurck
 * @return distance Arrow
 */
public double getDistance() {
	return distance;
}


/**
 * setzt die Distanz
 * @param distance Entfernung zum Hero (double)
 */
public void setDistance(double distance) {
	this.distance = distance;
	distanceAvailable = true;
}


/**
 * Returns the distanceAvailable.
 * @return boolean
 */
public boolean isDistanceAvailable() {
	return distanceAvailable;
}


/**
 * setzt distanceAvailable.
 * @param distanceAvailable boolean
 */
public void setDistanceAvailable(boolean distanceAvailable) {
	this.distanceAvailable = distanceAvailable;
}

/**
 * gibt die Richtung (als Winkel) zurck
 * @return direction double
 */
public double getDirection() {
	return direction;
}


public void setDirection(double direction) {
	this.direction = direction;
	directionAvailable = true;
}

/**
 * gibt an, ob die Richtung verfgbar ist
 * @return directionAvailable boolean
 */
public boolean isDirectionAvailable() {
	return directionAvailable;
}

/**
 * setzt die directionAvailable
 * @param directionAvailable boolean
 */
public void setDirectionAvailable(boolean directionAvailable) {
	this.directionAvailable = directionAvailable;
}


}
