/**
 * Basisklasse fr das Weltmodell
 * 
 * 23.05.02 Initialversion (T)
 * 24.05.02	Konstruktor teilweise mit leeren Daten gefllt (T)
 * 			processScoreEvent ausgefllt (F)
 * 			processInitEvent ausgefllt	(F)
 * 			processSenseBodyEvent ausgefllt (F)
 * 25.05.02	processHearEvent aufgefllt(T)
 * 26.05.02	Konstruktor gefttert (T)
 * 			getParty, getEnemy, getUnknowns gefllt (T)
 * 28.05.02	mit Klasse Positions verknpft (T)
 * 02.06.02 Konstruktor berarbeitet, insbesondere NullPointerExceptions entfernt (F)
 * 			processSeeEvents:	Abfrage ob Linien gesehen werden eingefgt
 * 								neue Variablennamen eingefhrt:
 * 									absViewAngle = angle
 * 									relViewAngle = helpangle
 *									angle 		 = absoluter Winkel zum Objekt
 * 								Bestimmung der Position fr naheste Flagge erstellt und getestet:
 * 								ACHTUNG manchmal NOCH UNBEKANNTE NullPointerException......
 * 03.06.02 NullPointerException entfernt (F)
 * 05.06.02 Positionsbestimmung des Hero umgestellt auf quadratisch gewichteten Mittelwert unter Berck
 * 			sichtigung aller erkannten Flags (F)
 * 			BEMERKUNG an Torben: Muss bei meinen Berechnungen noch einige Methoden "auslagern", hatte aber dazu keine zeit mehr...
 * 06.06.02 Fehler im Weltmodell bei der linken Linie im positiven Bereich berichtigt (F)
 * 			Winkel auch fr Rechtsnach Links berechnet (T)
 * 			Ballposition berechnet und Gewichte quadrasiert oder so hnlich (T)
 * 	
 * 07.06.02 TurnCount, MoveCount in processBodyEvent hinzugefgt (F)
 * 08.06.02	Attribut ballSeen eingefhrt und ball gefertigt (T)		
 * 			Player-Verarbeitung angefangen und TimeStampEvent hinzugefgt (T)
 * 09.06.02	Player-Verarbeitung bis auf den Vektor fertig gestellt(T)
 * 			Achtung: Es gibt noch keine Vergangenheit !!!
 *			Attribute ballDistance und ballDirection eingefhrt (bentigt fr Strategie) (J) 
 * 09.06.02 ballDistance und ballDirection wieder geloescht (F)
 * 			In processSeeObject NUR beim Ball die setDistance/setDirection aus Things gesetzt!
 * 12.06.02 processSeeEvent komplett berarbeitet, insbesondere calculate Methoden ausgelagert.
 * 			Nur die anderen Spieler muessen nochmal berarbeitet werden (F)
 * 12.06.02 Fehler in der 1.27 behoben!
 * 12.06.02 getparty,getenemy, getunknowns berichtigt (F)
 * 12.06.02 Seitenwechselproblem zur Halbzeit gelst (??) (F)
 *  		getDistance.isAvailable-Problem beim Ball gelst (F)
 * 14.06.02	den Vektor des Heros in Polarkoordinaten umgewandelt (T)
 * 16.06.02 Ersten Teil der Geschwindigkeit fertiggestellt.
 * 			Ball Vektor ist fertig, Other Player muessen noch berarbeitet
 * 			werden!!! (F/T)
 * 18.06.02 OtherPlayer fertig gestellt und party und enemy wieder in Vector umgewandelt (T)
 * 18.06.02 Nullpointerexception durch Initialisierung der Vektoren entfernt (F) 
 * 24.06.02 Spielstand erneuert! (F)
 * 
 * @author Torben Barth & Florian Strobel
 *
 * @version 1.32
 */

import java.util.Vector;
import java.lang.Math;

public class WorldModel {
	
	//Vektoren fr die unbekannten, eigenen und gegnerischen Spieler
	private Vector unknowns;
	private Vector enemy;
	private Vector party;

	private Things ball;
	private Hero yourself;
	private int ourScore;
	private int theirScore;
	private String teamName;
	//enthlt Matchstatus: Kickoff, freekick... (siehe Manual)
	private String matchStatus;
	//gibt an in welche Richtung wir spielen fr Links nach Rechts = 'l' sonst 'r'
	private char playDirection;
	//aktuelle Zeit der Weltmodells
	private int actTime;
	//enthlt Flaggen Positionen
	private Positions position;
	//gibt an, ob der Ball gesehen wird
	private boolean ballSeen;
	//stehen wir auf dem Feld
    private boolean onField;
    //sehen wir eine Linie
    private boolean lineVisible;

	

	/**
	 * Konstruktor
	 * @param teamName String
	 * @param isGoalie boolean
	 */
	public WorldModel(String teamName, boolean isGoalie) {
		yourself = new Hero(new Arrow(), new Arrow(), this);
		ball = new Things(new Arrow(), new Arrow(), this);
		yourself.setGoalie(isGoalie);
		ourScore = 0;
		theirScore = 0;
		ballSeen = false;
		actTime = 0;
		unknowns = new Vector(0);
		this.teamName = teamName;
		matchStatus = "before_kick_off";
		position = new Positions(this);
		party = new Vector(0);
		enemy = new Vector(0);
	}

	/**
	* verarbeitet HearEvent
	* bislang werden nur die Nachrichten von anderen Spieler verarbeitet
	* Coaches und Self werden nicht bercksichtigt
	* @param event HearEvent
	*/
	private void processHearEvent(HearEvent event) {
		//falls Nachricht von einem Spieler ist wird der Text in den Vektor heardText geschrieben
		if (!((event.getSender().equals("referee"))
			|| (event.getSender().equals("self"))
			|| (event.getSender().equals("online_coach_left"))
			|| (event.getSender().equals("online_coach_right"))))
			yourself.addHeardText(event);
		//falls die Bachricht vom Schiri ist wird sie in den matchtStatus geschrieben
		//und im Falle eines Tores wird das Ergebnis aktualisiert 
		if (event.getSender().equals("referee")) {
			matchStatus = event.getMessage();
			if (matchStatus.startsWith("goal_l_"))
			{
				if (playDirection=='l')
					ourScore = Integer.parseInt(matchStatus.substring(7));
				else theirScore = Integer.parseInt(matchStatus.substring(7));
			}
			else if (matchStatus.startsWith("goal_r_"))
			{
				if (playDirection=='r')
					ourScore = Integer.parseInt(matchStatus.substring(7));
				else theirScore = Integer.parseInt(matchStatus.substring(7));
			}
		}
	}

	/**
	* verarbeitet InitEvent
	* playDirection, Nummer und Matchstatus werden festgelegt
	* @param event InitEvent
	*/
	private void processInitEvent(InitEvent event) {
		playDirection = event.getSide();
		yourself.setNumber(event.getUnum());
		matchStatus = event.getPlayMode();
	}

	/**
	* verarbeitet ScoreEvent
	* aktuelles Ergebniss wird festgehalten
	* @param event ScoreEvent
	*/
	private void processScoreEvent(ScoreEvent event) {
		ourScore = event.getOurScore();
		theirScore = event.getTheirScore();
	}

	/**
	* bestimmt den Blickwinkel anhand einer gesehenen Linie
	* gibt ansonsten den alten Blickwinkel zurck
	* 
	* @param event SeeEvent
	* @return AbsViewAngle double
	*/
	private double calculateAbsViewAngle(SeeEvent event) {
		double absViewAngle = 0; //absoluter Blickwinkel
		double relViewAngle = 0; //vom Server angegebener Winkel
		
		//falls keine Linie gesehen wird, wird alte Position zurckgegeben
		if (event.lineCount() < 1) {
			return (yourself.getViewAngle());
		} else {
			//von links nach rechts

			//untere Linie
			if (event.getLine(0).getObjName().equals("l b")) {
				relViewAngle = event.getLine(0).getDirection();
				if (relViewAngle < 0)
					absViewAngle = -relViewAngle;
				else
				
					absViewAngle = 180.0 - relViewAngle;
			}

			//obere Linie
			if (event.getLine(0).getObjName().equals("l t")) {
				relViewAngle = event.getLine(0).getDirection();
				if (relViewAngle < 0)
					absViewAngle = -180.0 - relViewAngle;
				else
					absViewAngle = -relViewAngle;
			}

			//linke Linie
			if (event.getLine(0).getObjName().equals("l l")) {
				relViewAngle = event.getLine(0).getDirection();
				if (relViewAngle < 0)
					absViewAngle = 90.0 - relViewAngle;
				else
					absViewAngle = -90.0 - relViewAngle; //relViewAngle - 180;
			}

			//rechte Linie
			if (event.getLine(0).getObjName().equals("l r")) {
				relViewAngle = event.getLine(0).getDirection();
				if (relViewAngle < 0)
					absViewAngle = -90.0 - relViewAngle;
				else
					absViewAngle = 90.0 - relViewAngle;
			}

			//Winkel fr Spielrichtung Rechts nach Links
			if (playDirection == 'r') {
				//obere Linie
				if (event.getLine(0).getObjName().equals("l t"))
					absViewAngle = absViewAngle + 180.0;

				//untere Linie
				if (event.getLine(0).getObjName().equals("l b"))
					absViewAngle = absViewAngle - 180.0;

				//linke Linie
				if (event.getLine(0).getObjName().equals("l l"))
					if (relViewAngle > 0)
						absViewAngle = absViewAngle + 180.0;
					else
						absViewAngle = absViewAngle - 180.0;

				//rechte Linie
				if (event.getLine(0).getObjName().equals("l r"))
					if (relViewAngle > 0)
						absViewAngle = absViewAngle - 180.0;
					else
						absViewAngle = absViewAngle + 180.0;
			}

			return absViewAngle;
		}
	}

	/**
	* bestimmt die eigene Position anhand aller gesehenen Flaggen
	* Achtung: Es werden nur Flaggen mit allen Informationen bercksichtigt
	* Zur Fehlerminderung wird ein quadratisch gewichtetes Mittel der einzelnen Positionen genutzt
	* Gewichtungskriterium: gespiegelte Entfernung
	* 
	* @param event SeeEvent
	* @return selfPosition Arrow
	*/
	private Arrow calculateSelfPosition(SeeEvent event) {
		int sumOfFlags = 0; //Anzahl der gesehenen Flaggen
		int IndexOfnearestFlag; //wird zur Mittelbildung bentigt
		int IndexOfwidestFlag; //wird zur Mittelbildung bentigt	

		sumOfFlags = event.flagCount(); //Bestimme Anzahl der gesehenen Flaggen

		boolean knowall[] = new boolean[sumOfFlags];
		//true, falls Name, direction und distance der Flagge bekannt sind
		double middle; // Mitte zwischen der nahesten und weitesten Flagge
		double angle; // absoluter Winkel zwischen Betrachter und Flagge 
		double relXValue; //relative X Position anhand einer Flagge
		double relYValue; //relative Y Position anhand einer Flagge
		double xValue[] = new double[sumOfFlags];
		//absolute X Position anhand der Flagge i
		double yValue[] = new double[sumOfFlags];
		//absolute Y Position anhand der Flagge i
		double weigth[] = new double[sumOfFlags];
		//Gewicht der Flagge i fr den Mittelwert
		double sumxValue = 0; //Summe der gewichteten X-Positionen
		double sumyValue = 0; //Summe der gewichteten Y-positionen
		double sumweigth = 0; //Summe der Quadrat-Ggewichte
		double midxValue = 0; //gemittelte x-Position
		double midyValue = 0; //gemittelte y-Position

		//Wenn eine Flagge gesehen wird
		if (sumOfFlags >= 1) {
			IndexOfnearestFlag = 0;
			IndexOfwidestFlag = 0;

			//Durchlaufe alle Flagggen:
			//Bestimme die Flags, wo alle Informationen vorhanden sind
			//Bestimme Index der nahesten und der weitesten Flag
			for (int IndexOfFlag = 0;
				IndexOfFlag < sumOfFlags;
				IndexOfFlag++) {
				//Wenn Name, direction und Distance bekannt ist
				if (event.getFlag(IndexOfFlag).getDistanceAvailable()
					&& event.getFlag(IndexOfFlag).getDirectionAvailable()
					&& !event.getFlag(IndexOfFlag).getObjName().equals("F")
					&& !event.getFlag(IndexOfFlag).getObjName().equals("G")) {
					knowall[IndexOfFlag] = true;

					//Bestimme Index der nahesten Flagge
					if (event.getFlag(IndexOfnearestFlag).getDistance()
						>= event.getFlag(IndexOfFlag).getDistance()) {
						IndexOfnearestFlag = IndexOfFlag;
					}

					//Bestimme Index der weitesten Flagge
					if (event.getFlag(IndexOfwidestFlag).getDistance()
						<= event.getFlag(IndexOfFlag).getDistance()) {
						IndexOfwidestFlag = IndexOfFlag;
					}
				}

				//Falls Name oder direction oder distance unbekannt
				else
					knowall[IndexOfFlag] = false;
			}

			//Bestimme die Mitte zwischen der max. und der min. Entfernung
			middle =
				(event.getFlag(IndexOfnearestFlag).getDistance()
					+ event.getFlag(IndexOfwidestFlag).getDistance())
					/ 2.0;

			//Durchlaufe alle Flags mit allen Informationen und berechne Gewichte
			//incl. der jeweils durch die Flag gegebenen Position
			for (int IndexOfFlag = 0;
				IndexOfFlag < sumOfFlags;
				IndexOfFlag++) {
				//Wenn alle Direction, Distance und Name der Flagge vorhanden sind
				if (knowall[IndexOfFlag]) {
					//Bestimme absoluten Winkel (Sichtwinkel + geg. Winkel vom Server)
					angle =
						yourself.getViewAngle()
							+ event.getFlag(IndexOfFlag).getDirection();

					//bestimme relative Position anhand der Flagge
					relXValue =
						Math.cos(Math.toRadians(angle))
							* event.getFlag(IndexOfFlag).getDistance();
					relYValue =
						Math.sin(Math.toRadians(angle))
							* event.getFlag(IndexOfFlag).getDistance();

					//rechne relative Koordinaten in absolute um	
					xValue[IndexOfFlag] =
						position.getArrowX(
							event.getFlag(IndexOfFlag).getObjName())
							- relXValue;
					yValue[IndexOfFlag] =
						position.getArrowY(
							event.getFlag(IndexOfFlag).getObjName())
							- relYValue;

					//Bestimme Gewicht durch Spiegelung der Entfernung an der Mitte
					weigth[IndexOfFlag] =
						(2.0 * middle)
							- event.getFlag(IndexOfFlag).getDistance();

					//Summiere "quadrat - gewichtete" X/Y Positionen auf
					sumxValue =
						sumxValue
							+ (weigth[IndexOfFlag]
								* weigth[IndexOfFlag]
								* xValue[IndexOfFlag]);
					sumyValue =
						sumyValue
							+ (weigth[IndexOfFlag]
								* weigth[IndexOfFlag]
								* yValue[IndexOfFlag]);
					sumweigth =
						sumweigth + (weigth[IndexOfFlag] * weigth[IndexOfFlag]);
				}

				midxValue = sumxValue / sumweigth; //Bilde Mittel
				midyValue = sumyValue / sumweigth; //Bilde Mittel
			}
			return (new Arrow(midxValue, midyValue));
		} else {
			return (yourself.getPosition());
		}
	}

	/**
	* bestimmt die Position des Balls, gibt ansonsten alte Position zurck
	* 
	* @param event SeeEvent
	*/
	private void calculateBallPosition(SeeEvent event) {
		double objAngle; //absoluter Winkel zum Ball
		double xBall; //relative X-Koordinate des Balls
		double yBall; //relative Y-Koordinate des Balls
		double dischange, dirchange;
		
		//wird nur gendert, falls Direction und Distance vom Ball gesehen werden
		ballSeen = false;
		ball.setDirectionAvailable(false);
		ball.setDistanceAvailable(false);
		
		//Wenn der Ball gesehen wird
		if (event.ballCount() > 0) {
			//Wenn Distance und Direction gesehen wird
			if (event.getBall(0).getDistanceAvailable()
				&& event.getBall(0).getDirectionAvailable()) {
				//Berechne relative BallPosition
				objAngle =
					yourself.getViewAngle() + event.getBall(0).getDirection();
				xBall =
					event.getBall(0).getDistance()
						* Math.cos(Math.toRadians(objAngle));
				yBall =
					event.getBall(0).getDistance()
						* Math.sin(Math.toRadians(objAngle));

				//Bestimme absolute Ballposition
				Arrow ballArrow = new Arrow(xBall, yBall);
				ballArrow.addArrow(yourself.getPosition());

				ballSeen = true;

				ball.setPosition(ballArrow);
				setDistanceandDirection(event);
				
				//falls Richtungs- und Entfernungsnderung vorhanden berechne Geschwindigkeits-/Richtungsvektor
				if (event.getBall(0).getDistChangeAvailable() && event.getBall(0).getDirChangeAvailable())
				{
					dirchange = event.getBall(0).getDirChange();
					dischange = event.getBall(0).getDistChange();
					calculateSpeedVector(ball, dirchange, dischange);
				}				
			}
			else setDistanceandDirection(event);
		}
	}

	/**
	* bestimmt die Position der anderen Spieler 
	* 
	* @param SeeEvent
	*/
	private void calculateOtherPosition(SeeEvent event) {
		double objAngle; //abs. Winkel zum Spieler 
		double xPlayer; // relative x-Koordinate des Spielers
		double yPlayer; // relative y-Koordinate des Spielers

		//setze Vektoren zurck
		unknowns.clear();
		party.clear();
		enemy.clear();

		//Durchlaufe alle gesehenen Spieler
		for (int i = 0; i < event.playerCount(); i++) 
		{
			//Wenn Direction und Distance gesehen wird
			if (event.getPlayer(i).getDirectionAvailable()
				&& event.getPlayer(i).getDistanceAvailable()) 
			{	
				//Bestimme relative Position
				objAngle =
					yourself.getViewAngle() + event.getPlayer(i).getDirection();
				xPlayer =
					event.getPlayer(i).getDistance()
						* Math.cos(Math.toRadians(objAngle));
				yPlayer =
					event.getPlayer(i).getDistance()
						* Math.sin(Math.toRadians(objAngle));

				//Bestimme absolute Position
				Arrow playerArrow = new Arrow(xPlayer, yPlayer);
				playerArrow.addArrow(yourself.getPosition());

				//Erstelle neuen Spieler
				Player player =
					new Player(new Arrow(), new Arrow(), this);

				//Setze Direction und Distance
				player.setDirection(event.getPlayer(i).getDirection());
				player.setDistance(event.getPlayer(i).getDistance());				
				
				
				//Setze Spielereigenschaften
				
				//Prfe, ob Mannschaft bekannt
				//wenn Mannschaft bekannt setzte Mannschaft
				if (event.getPlayer(i).isTeamNameAvailable())
				{	
					player.setKnown(true);
					if(event.getPlayer(i).getTeamName().equals(teamName))
						player.setPartyMember(true);
				}
				
				//wenn Nummer vorhanden ist
				if	(event.getPlayer(i).isUniformNumberAvailable()) 
				{
					player.setNumber(event.getPlayer(i).getUniformNumber());
					player.setNumberAvailable(true);
				}
				
				//wenn klar ist, ob Spieler Torwart ist oder nicht
				if(event.getPlayer(i).isGoalieAvailable())
				{
					player.setGoalieAvailable(true);
					if(event.getPlayer(i).isGoalie())
						player.setGoalie(true);
				}	
					
				player.setPosition(playerArrow);
						
				//Falls Geschwindigkeit verfgbar setzte Geschwindigkeit des Spielers
				if (event.getPlayer(i).getDirChangeAvailable()
					&& event.getPlayer(i).getDistChangeAvailable()) 
					calculateSpeedVector(player, event.getPlayer(i).getDirChange(), event.getPlayer(i).getDistChange());	
						
				
				//Spieler in den passenden Vektor einfgen
				//Achtung: es wird noch keine Vergangenheit miteinbezogen
				
				if(player.isKnown() == false)
				{
					unknowns.add(player);
				}
				else
					if(player.isPartyMember())
						party.add(player);
					else enemy.add(player);
				
			}
		}			
	}
	
	/**
	* berechnet Geschwindigkeitsvektor
	* 
	* @param object Things
	* @param dirchange double
	* @param dischange double
	*/
	private void calculateSpeedVector(Things object, double dirchange, double dischange)
	{
		double prx,pry;
		double erx,ery;
		double vrx, vry;
		double vtx, vty;
		
		//Berechnung anhand der Formeln aus dem Manual
		prx = object.getPosition().getX() - yourself.getPosition().getX();
		pry = object.getPosition().getY() - yourself.getPosition().getY();
		
		//nur falls Entfernung vorhanden ist Berechnung mglich
		if (object.isDistanceAvailable())
		{
			erx = prx / object.getDistance();
			ery = pry / object.getDistance();
			
			vry = ((Math.PI * object.getDistance() * dirchange * erx) + (180.0 * dischange * ery)) / (180.0 * ((ery * ery) + (erx * erx)));
			vrx = (dischange - (vry * ery)) / erx;
			
			vtx = vrx + yourself.getVector().getX();
			vty = vry + yourself.getVector().getY();
			
			object.setVector(new Arrow(vtx, vty));
			
		}
		else 
		{
			System.err.println("SpeedVector kann nicht berechnet werden (Distance fehlt)");
		}
		
		
	}

	/**
	* setzt die Distance und die Direction des Balls fest
	* 
	* @param event SeeEvent
	*/
	private void setDistanceandDirection(SeeEvent event) {
		//Wenn der Ball gesehen wird
		if (event.ballCount() > 0) {

			if (event.getBall(0).getDistanceAvailable()) {
				ball.setDistance(event.getBall(0).getDistance());
			}

			if (event.getBall(0).getDirectionAvailable()) {
				ball.setDirection(event.getBall(0).getDirection());
			}
		}
	}

	/**
	* verarbeitet SeeEvent
	* 
	* - Bestimmt Blickwinkel (absViewAngel) anhand einer gesehenen Linie
	* - Bestimmt eigene Position anhand aller Flaggen (nur die mit allen Informationen)
	* - Bestimmt Position des Balls
	* - Bestimmt Position der anderen Spieler (noch keine Vgh. Werte werden bercksichtigt)
	* 
	* @param event SeeEvent
	*/
	private void processSeeEvent(SeeEvent event) {
		double absViewAngle = 0; //Blickwinkel
		Arrow selfPosition = new Arrow(); //Eigene Position

		onField = (event.lineCount() == 1);
		lineVisible = (event.lineCount() > 0);
		
		// Bestimme Blickwinkel anhand einer gesehenen Linie, ansonsten gib alten zurck 
		absViewAngle = calculateAbsViewAngle(event);
		yourself.setViewAngle(absViewAngle);

		// Berechne eigene Position anhand aller gesehenen Flaggen, ansonsten gib alte Position zurck
		selfPosition = calculateSelfPosition(event);
		yourself.setPosition(selfPosition);

		//Berechne Position des Balls anhand eigener Position, falls Ball sichtbar, ansonsten alten Wert und ballseen = false!!
		calculateBallPosition(event);
		
		//Berechne Positionen von den anderen Spielern	
		calculateOtherPosition(event);
	}

	/**
	* verarbeitet SenseBodyEvent, schreibt einfach die Eigenschaften in den yourself
	* @param event SenseBodyEvent
	*/
	private void processSenseBodyEvent(SenseBodyEvent event) {
		yourself.setViewModeAngle(event.getViewModeAngle());
		yourself.setViewModeInterval(event.getViewModeInterval());
		yourself.setStamina(event.getStamina());
		yourself.setEffort(event.getEffort());
		yourself.setTurnCount(event.getTurnCount());
		yourself.setMoveCount(event.getMoveCount());
		
		//Berechnung des Richtungs-/Geschwindigkeitsvektors
		double xVector =
			event.getAmountOfSpeed()
				* Math.cos(
					Math.toRadians(
						event.getDirectionOfSpeed() + yourself.getViewAngle()));
		double yVector =
			event.getAmountOfSpeed()
				* Math.sin(
					Math.toRadians(
						event.getDirectionOfSpeed() + yourself.getViewAngle()));
		Arrow vektor = new Arrow(xVector, yVector);
		
		yourself.setVector(vektor);
		yourself.setHeadAngle(event.getHeadAngle());
	}

	/**
	* verarbeitet die verschiedenen Ereignisse, die an das Weltmodell gegeben werden.
	* @param event ServerEvent
	*/
	public void addEvent(ServerEvent event) {
		if (event instanceof TimeStampedEvent) {
			TimeStampedEvent tse = (TimeStampedEvent) event;
			actTime = tse.getTimeStamp();
		}

		if (event instanceof HearEvent) {
			processHearEvent((HearEvent) event);
		} else if (event instanceof InitEvent) {
			processInitEvent((InitEvent) event);
		} else if (event instanceof ScoreEvent) {
			processScoreEvent((ScoreEvent) event);
		} else if (event instanceof SeeEvent) {
			processSeeEvent((SeeEvent) event);
		} else if (event instanceof SenseBodyEvent) {
			processSenseBodyEvent((SenseBodyEvent) event);
		}
	}

	/**
	 * Gibt an wieviele Spieler gesehen werden, die in unserer Mannschaft spielen.
	 * @return partyCount int
	 */
	public int getPartyCount() {
		return party.size();
	}

	/**
	 * Gibt an wieviele Spieler gesehen werden, die in der gegnerischen Mannschaft spielen.
	 * @return enemyCount int
	 */
	public int getEnemyCount() {
		return enemy.size();
	}

	/**
	 * Gibt an wieviele zur Zeit unerkannte Spieler es gibt (ist keiner Mannschaft zu zuordnen)
	 * @return unknownsCount int
	 */
	public int getUnknownsCount() {
		return unknowns.size();
	}

	/**
	 * Gibt den Spieler unseres Teams mit der Nummer i zurck.
	 * @param num int
	 * @return Player
	 */
	public Player getParty(int num) {
		return (Player) party.elementAt(num - 1);
	}

	/**
	 * Gibt den nicht zu zuordenden Spieler  an der Stelle i>=1 zurck.
	 * @param num int
	 * @return Player
	 */
	public Player getUnknowns(int num) {
		return (Player) unknowns.elementAt(num - 1);
	}

	/**
	 * Gibt den Spieler des gegnerischen Teams mit der Nummer i zurck.
	 * @param num int
	 * @return Player
	 */
	public Player getEnemy(int num) {
		return (Player) enemy.elementAt(num - 1);
	}

	/**
	 * gibt die Anzahl unserer Tore zurck
	 * @return ourScore int
	 */
	public int getOurScore() {
		return ourScore;
	}

	/**
	 * gibt die Anzahl der gegnerischen Tore zurck
	 * @return theirScore int
	 */
	public int getTheirScore() {
		return theirScore;
	}

	/**
	 * Gibt den Matchtstatus zurck (Freisto, Absto, Halbzeit,...)
	 * @return matchStatus String
	 */
	public String getMatchStatus() {
		return matchStatus;
	}

	/**
	 * gibt an in welche Richtung wir spielen
	 * @return playDirectionString
	 */
	public char getPlayDirection() {
		return playDirection;
	}
	
	/**
	 * gibt die aktuelle Zeit des Weltmodells zurck
	 * @return actTime int
	 */
	public int getActTime() {
		return actTime;
	}

	/**
	 * gibt den Hero zurck
	 * @return yourself Hero
	 */
	public Hero getYourself() {
		return yourself;
	}

	/**
	 * Gets the ball.
	 * @return ball Things
	 */
	public Things getBall() {
		return ball;
	}

	/**
	 * Gibt an, ob der Ball gesehen wird
	 * @return ballSeen boolean
	 */
	public boolean isballSeen() {
		return ballSeen;
	}

	/**
	 * Returns the teamName.
	 * @return teamName String
	 */
	public String getTeamName() {
		return teamName;
	}

	/**
	 * gibt an, ob der Spieler auf dem Feld spielt
	 * @return onField boolean
	 */
    public boolean isOnField()
    {
	return onField;
    }

	/**
	 * gibt an, ob eine Linie gesehen wird
	 * @return lineVisible boolean
	 */
    public boolean isLineVisible()
    {
	return lineVisible;
    }
}
